# Helpers for NLP intent declaration
from helpers.intent import intent, list_intents
from helpers.intent_cog import IntentCog

# Actions that intents can trigger
import actions.guild as guild_actions


class GuildCog(IntentCog):
    def __init__(self, bot):
        self.bot = bot

    @intent([["guild"], ["help"]])
    async def guild_help_intent(self, ctx, doc):
        await ctx.send("Full help is not really possible at this stage. I'll try to understand what you're saying and match it to what you're wanting to do.")
        lines = []
        for i, intent in enumerate(list_intents(), start=1):
            pattern_str = " + ".join(f"[{', '.join(group)}]" for group in intent["pattern"])
            lines.append(f"{i}. `{intent['func_name']}` from **{intent['cog']}** → {pattern_str}")

        message = "\n".join(lines) or "No intents registered."
        await ctx.send(f"**Registered Intents:**\n{message}")

    @intent([["guild"], ["create"]])
    async def guild_create_intent(self, ctx, doc):
        # Expected phrase: create guild "asd"
        #              or: guild create "asd"
        # Will not work for anyone but kpro or PM
        OWNERS=['214577944570494976','1088598275562668195']
        OWNERS=['214577944570494976']
        if ctx.author.id not in OWNERS:
            await ctx.reply('Sorry but you are not authorized')

async def setup(bot):
    await bot.add_cog(GuildCog(bot))

