from discord.ext import commands
from helpers.intent import intent_handlers

class IntentCog(commands.Cog):
    def cog_load(self):
        # Clear existing handlers for this cog, if you want to avoid duplicates:
        # intent_handlers[:] = [h for h in intent_handlers if h.get("func").__self__ != self]

        for attr_name in dir(self):
            attr = getattr(self, attr_name)
            if callable(attr) and hasattr(attr, "_intent_pattern"):
                intent_handlers.append({
                    "pattern": attr._intent_pattern,
                    "func": attr,  # Bound method (includes self)
                })

