import spacy

nlp = spacy.load("en_core_web_sm")

# Define intent keywords
INTENTS = {
    "create_guild": [["create", "make", "new"], ["guild"]],
    "list_guilds": [["list", "show", "display"], ["guild"]],
}

def detect_intent(text):
    doc = nlp(text.lower())
    tokens = [token.lemma_ for token in doc if not token.is_stop]

    for intent, keyword_groups in INTENTS.items():
        # Check if any keyword in each group is present
        if all(any(kw in tokens for kw in group) for group in keyword_groups):
            return intent
    return "unknown"

def analyze(text):
    doc = nlp(text.lower())

    print("\nChecking for stop words")
    for token in doc:
        print(f"{token.text} (is_stop={token.is_stop})")

    print("\nChecking for punctuation")
    for token in doc:
        print(f"{token.text} (is_punct={token.is_punct})")

    print("\nChecking intent")
    intent = detect_intent(text)
    print(f"{text} ({intent})")

#print(detect_intent("list guilds"))
analyze("list guilds")

print("give" in nlp.Defaults.stop_words)
print(nlp("give")[0].is_stop)

